// Channel Decomposition software server module 
#ifndef __VSI_CHDCON_SRV__
#define __VSI_CHDCON_SRV__

#include "netutl.h"

const int Max_Dmy_Client = 5;

extern char *me;
const int Get_myport(Socket& s);

//-----------------------------------------------------------------
//// Server Class cor Master Client 
class Mst_Data_Dstr_Server:public Thread{
  /// Socket for Master data distribution server class 
  Socket& _out_sock1;
  /// Pointer array of Sockets for dummy clients class
  Socket* _out_sock2[Max_Dmy_Client];
  /// pointer to a receiver class
  Recv_mem_simple* recv_mem;
  /// Counter of dumy clients.
  int dmy_clt_cnt;
  /// 
  static int nClientID;
 public:
  Mst_Data_Dstr_Server(Socket &s1);
  void* thread_func(void);
  /// A function starting the thread
  void proc(){start();}
  int Add_dmyClnt(Socket* s);
   /// Remove the entry of dummy client
  void Rm_dmyClnt(int id){if (_out_sock2[id]!=0) _out_sock2[id]=0;}
  /// Set data receiver 
  void Set_Receiver( Recv_mem_simple* rv){recv_mem = rv;}
  int CommunicateWithClient();
  int Dist_start(Socket& sock, const int); // Data Provider 
  void Close_sockets();
  /// Return number of dumy clients.
  const int NDmyClient()const {return nClientID;}
};
int Mst_Data_Dstr_Server::nClientID = 0;

/// Constructor 
inline Mst_Data_Dstr_Server::Mst_Data_Dstr_Server(Socket &s1): 
  _out_sock1(s1),dmy_clt_cnt(0)
{
  for(int i=0; i<Max_Dmy_Client; i++){
    _out_sock2[i]=0;
  }
}

/// ߡ() 饤Ȥɲ
inline int Mst_Data_Dstr_Server::Add_dmyClnt(Socket* s){

  // Check the number 
  int n=0;
  for(int i=0;i<Max_Dmy_Client; i++)
    if(_out_sock2[i]!=0) n++;
  dmy_clt_cnt =n;

  if( dmy_clt_cnt >= Max_Dmy_Client){
    fprintf(stderr,"Client Too Much (already %d), Connection refused.\n",
	    dmy_clt_cnt);
    if(s->get_sockd() != -1) s->close();
    delete s;
    return -1;
  }
  int i=0;
  while(i<Max_Dmy_Client && _out_sock2[i]!=0) i++;
  if( i==Max_Dmy_Client){
    if(s->get_sockd() != -1) s->close();
    delete s; return -1;
  }
  _out_sock2[i]=s;
  dmy_clt_cnt++;
  return dmy_clt_cnt-1;
}


/// ޥ() 饤 Thread ؿ
inline void* Mst_Data_Dstr_Server::thread_func(void){

  int ret=0;
  if(nClientID !=0){
    fprintf(stderr,"Mst_Data_Dstr_Server is already running\n");
  }else{
    nClientID++; 
    while( (ret=CommunicateWithClient()) ==-1);
    nClientID--;
  }
  if(ret!=-2) 
    proc(); // Generate other thread for next connection

}

/// Server communication with client 
inline int Mst_Data_Dstr_Server::CommunicateWithClient(){
  static int err_cntr=0;
  int ThreadSock;
  Socket* tcp_sock;
  if(err_cntr>10) return -2;

  fprintf(stderr,"Waiting for connection from Mstr Clnt...");
  if( (ThreadSock = _out_sock1.accept()) == -1){
    fprintf(stderr,"Error in MST Srv Accept (errno=%d) \n", errno);
    perror("Accept Error");
    _out_sock1.Error();
    err_cntr++;
    return -1;
  }else{
    fprintf(stderr, "accepted\n");
    tcp_sock = new TCPSocket(ThreadSock,_out_sock1.get_mtu());
    tcp_sock->Print();
  }
  
  // Receive request and payload-config  
  Payload payld;
  long status;
  if((status = tcp_sock->recv((u_int8_t *)&payld, sizeof(payld))) <=0){
    if(status ==0){
      fprintf(stderr,"Connection is already closed\n");
      err_cntr++;
      return -1;
    }else if(status == -1){
      fprintf(stderr,"Error in recv() (errno=%d):%s \n", 
	      errno, strerror(errno));
      err_cntr++;
      return -1;
    }
  }
  if(status != sizeof(payld)){
    fprintf(stderr,"%s :Error received size(%d) < Expecting (%d)\n",
	    me, status,  sizeof(payld)); 
    err_cntr++;
    return -1;
  } 
  fprintf(stderr,"Payload Contents for Client----\n");
  payld.Print();
  fprintf(stderr,"-------------------------------\n");
  recv_mem->Set_payload(payld);

  // Data Receiver start 
  recv_mem->proc();
    
  // Data Provider start
  int dur = payld.length/payld.clock;
  Dist_start(*tcp_sock, dur);
  recv_mem->Set_ApplState(STOP_STATE);
  recv_mem->join();
  Close_sockets();
  delete tcp_sock;
  err_cntr=0;
  return 0;
}

/// Data Distributer
inline int Mst_Data_Dstr_Server::Dist_start(Socket &sock, const int dur){


  long long data_size=0;
  while(data_size==0){ data_size= recv_mem->Get_Pagesize(); usleep(1);}
  unsigned long long total_byte=0;
  long status;

  fprintf(stderr,"Dist_start begin, data_size=%ld\n", data_size);

  int jpage=-1;
  for(int  isec=0; isec<dur; isec++){
    jpage = isec % 2;
    status = recv_mem->Check_forRead(jpage);
    switch(status){
    case -1:
      fprintf(stderr,"Memory page (%d)is not available\n", isec%2);
      return -1;break;
    case -2:
      fprintf(stderr,"Send out last once\n");
     isec=dur; break;
    }
    //    u_int8_t* rdadr = recv_mem->Get_Rpoint();
    u_int8_t* rdadr = recv_mem->Get_page_addr(jpage);
    //    u_int8_t* wradr = recv_mem->Get_Rpoint();
    if(rdadr ==0){
      fprintf(stderr,"Read address is not ready\n");
      return -1;
    }
//     unsigned long long  adr_dif;
//     if(wradr > rdadr) adr_dif =wradr-rdadr;
//     else  
//       adr_dif = recv_mem->Get_page_addr(1) + data_size - rdadr
// 	+ (wradr-recv_mem->Get_page_addr(0));
    //    long long remain_data =Min((unsigned long long)data_size,(unsigned long long)adr_dif);

    //    long long remain_data =data_size;
    long long remain_data = data_size;
    // Sending data to Master Client

    while(remain_data >0){
      status = sock.send(rdadr, Min(data_size,remain_data));
      if(debug_level >-1) 
	fprintf(stderr,"%.3f MB Sent\n", (float)status*1.e-6);
      if(status < 0){
	fprintf(stderr, "%s Error in sending data to Master Client\n",me);
	return -1;
      }else if(status ==0){
	fprintf(stderr, "%s Master Client is already closed.\n",me);
	//      return -1;
	continue;
      }
      remain_data-=status;
      rdadr += status;
    }
    total_byte += data_size;

    // Sending data to Dumy Client
    for(int i=0; i<dmy_clt_cnt; i++){
      if(_out_sock2[i] == 0) continue;
      rdadr = recv_mem->Get_page_addr(jpage);
      remain_data =data_size;
      int err_cnt=0;
      while(remain_data >0){
	status = _out_sock2[i]->send(rdadr, Min(data_size,remain_data));
	//	status = _out_sock2[i]->send(rdadr, data_size);
	if(status < 0){
	  fprintf(stderr, "%s Error in sending data to Master Client\n",me);
	  fprintf(stderr, "Socket[%d] is destroyed,\n",i);
	  perror("send to Dmy socket");
	  if( _out_sock2[i]->get_sockd() !=-1)  _out_sock2[i]->shutdown(SHUT_RDWR);
	  delete _out_sock2[i];
	  _out_sock2[i]=0;
	  //	  return -1;
	  break;
	}else if(status ==0){
	  if(err_cnt < 10) {err_cnt++; continue;}
	  fprintf(stderr, "%s Master Client is already closed.\n",me);
	  fprintf(stderr, "Socket[%d] is destroyed,\n",i);
	  if( _out_sock2[i]->get_sockd() !=-1)  _out_sock2[i]->shutdown(SHUT_RDWR);
	  delete _out_sock2[i];
	  _out_sock2[i]=0;
	  //	  return -1;
	  break;
	} 
	err_cnt=0;
	remain_data -=status;
	rdadr += status;
      } // while loop
    } // for dmy
    status = recv_mem->Read_finsh(jpage);
  }// for sec

  fprintf(stderr,"Total (%.3f MB) sent Succesfully\n",
	  (float)total_byte*1.e-6);
  return 0;
}

/// Sockets Υ
inline void  Mst_Data_Dstr_Server::Close_sockets(){
  //  _out_sock1.close();
  for(int i=0; i<Max_Dmy_Client; i++)
    if( _out_sock2[i] !=0){
      _out_sock2[i]->close();
      delete _out_sock2[i];
      _out_sock2[i]=0;
    }
}

//-----------------------------------------------------------------
/// Server Class cor Dumy Client 
class Dmy_Data_Dst_Server:public Thread{
  /// Sockets assigned for each dummy client 
  Socket& _out_sock;
  /// Number of dummy clients entries 
  static int nClientID;
  /// Pointer to master data server class
  Mst_Data_Dstr_Server* mst_srv;
 public:
  Dmy_Data_Dst_Server(Socket& s):_out_sock(s),mst_srv(0){;}
  void* thread_func(void);
   /// A function starting the thread
  void proc(){start();}
  /// Set a pointer of Master data server class
  void Set_Master(Mst_Data_Dstr_Server* mst){mst_srv = mst;}
};
int Dmy_Data_Dst_Server::nClientID = 0;

/// ߡ()饤 Thread 
inline void* Dmy_Data_Dst_Server::thread_func(void){

  // Master data server start
  mst_srv->proc();
  
  if(nClientID !=0){
    fprintf(stderr,"Dmy_Data_Dst_Server is already running\n");
  }else{
    nClientID++;
    
    int mtu = _out_sock.get_mtu();
    int ThreadSock;
    while(1){
      if( (ThreadSock = _out_sock.accept()) == -1){
	fprintf(stderr,"Error in DMY Srv Accept (errno=%d) \n", errno);
	perror("Accept Error");
	_out_sock.Error();
	//    Error_accept();
	return (void*)-1;
      }
      fprintf(stderr, "Connection accepted by Dmy Client\n");
      if( mst_srv->NDmyClient() >= Max_Dmy_Client) continue;
      _out_sock.Print();
      
      Socket* tcp_sock = new TCPSocket(ThreadSock,mtu);
      mst_srv->Add_dmyClnt(tcp_sock);
    }
    nClientID--;
  }
  
}





#endif
