
#ifndef _THREAD_AP1_
#define _THREAD_AP1_

#include <vector>
using namespace std;

extern "C" {
#include <signal.h>
#include <wchar.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/shm.h>
#include <unistd.h>
}

#include "Thread.h"
#include "FileSocket.h"
#include "TCPSocket.h"
#include "FileSocket.h"
#include "payload.h"
#include "netutl.h"

static int mode = FILE2NET;
//static int nClientID=0;
char * me; /* My name */
enum {TALKER, VSI2000};

extern char* me;
extern int nClientID;

class ThreadDMY: public Thread
{
 protected:
  Socket& _out_sock;
  int shem_id;  // Shared memory ID;
  unsigned long shem_size; // Shared memory size 
  int LocalClientID;
  static int nClientID;
  int mode;
  string fname;
  int ch_id;
public:
  ThreadDMY(const ThreadDMY& th);
  ThreadDMY( Socket& out_sock);
  ~ThreadDMY(){ 
    nClientID--; 
    int ret;
    if(ret = shmctl(shem_id,IPC_RMID,0)==-1 )
      perror("shmctl:remove shem_id");
    else
      fprintf(stderr,"Shared memory(id=%d) %.3f MB is released\n", 
	      shem_id, (float)shem_size*1.e-6); 
  }
  
  virtual void* thread_func(void);
  virtual void* proc(){Thread::start();}
  void Set_outsock(Socket& s){_out_sock=s;}
  //  void Set_shem(int id, unsigned long sz){shem_id=id; shem_size=sz;}
  void CpyShem(const ThreadDMY& th){
    shem_id=th.shem_id;shem_size=th.shem_size; fname = th.fname;}
  void Set_mode(const int m){mode=m;}
  void Set_fname(const string& f){fname=f;}
  void Set_channel(const int ch){ch_id=ch;}
  const int NClient() const {return nClientID;}
  int shem_init(const unsigned long sz);
 private:
    void  CommunicateWithClient();
    void  SendingFileToClient();
};

int ThreadDMY::nClientID = 0;

/* template <class T> */
/* inline const T Min( const T& a, const T&b) */
/* {  return (a > b ? b : a);} */

// Copy Constructor 
inline
ThreadDMY::ThreadDMY(const ThreadDMY &th):
  _out_sock(th._out_sock),shem_id(th.shem_id), 
     shem_size(th.shem_size),mode(th.mode),ch_id(-1)
{ 
  LocalClientID=nClientID++;
}

// Constructor 
inline 
ThreadDMY::ThreadDMY( Socket& out_sock):
  _out_sock(out_sock),mode(TALKER)
{
  LocalClientID=nClientID++;
  shem_size=0;
  shem_id=-1;
}


// Communications with Client 
inline void  ThreadDMY::CommunicateWithClient(){
  
  int status;

  int mtu2 = _out_sock.get_mtu();
  //  u_int8_t sRecvBuf[mtu1];  // Хåե
  u_int8_t sSendBuf[mtu2];  // Хåե
  //  u_int8_t sSendBuf[256];  // Хåե
  
  u_int8_t* dat_adr;

  if((dat_adr = (u_int8_t*)shmat(shem_id,0,SHM_RDONLY)) == (u_int8_t*)-1){
    fprintf(stderr,"ComWithClient: Shard Memory Attach Error \n");
    perror("ComWithClient");
    exit(1);
  }
  
  fprintf(stderr,"%s DEBUG: ComWitnClient(%d) Started\n", 
	  me,  LocalClientID);
  fd_set wfd;
  int nsize=0;
  u_int32_t tbyte=0;
  int cnt=0;
  int ret;
  u_int8_t buf[sizeof(Payload)*2];
  Payload*  pld=(Payload*)buf;
  long long total_byte0;


  if( mode == VSI2000){
    status = _out_sock.recv((u_int8_t*)pld, sizeof(Payload));
    if( status <=0){
      perror("Payload Recv Error,");
      return; 
    }else{
      fprintf(stderr,"\nPayload Contents-------------\n");
      pld->Print();
      fprintf(stderr,"-----------------------------\n");
    }
    char time_code[80], time_code_st[80];
    time_t t_now = time(0),t1;
    strftime(time_code,sizeof(time_code),"%Y/%j %H:%M:%S",gmtime(&t_now));
    strftime(time_code_st,sizeof(time_code_st),
	     "%Y/%j %H:%M:%S",gmtime(pld->aEpoch(t1)));
    time_t dur = pld->length/pld->clock;
    total_byte0 = pld->length*4;// 32bits stream is assumed      

    if(pld->Wait(dur) < 0){
      _out_sock.close();
      //      _out_sock.shutdown(SHUT_RDWR);
      fprintf(stderr," Connection Closed\n");
      return;
    }
    fprintf(stderr, "Sending data (%.3f MB) started\n",
	    (float)total_byte0*1.e-6);
  }

  if(mode != VSI2000)  total_byte0=32000000;
  fprintf(stderr,"Sending data= ");
  for(int i=0; i<4; i++) 
    fprintf(stderr,"%0x%0x%0x%0x ",
	    dat_adr[0],dat_adr[1],dat_adr[2],dat_adr[3]);
  fputc('\n',stderr);
  
  unsigned long long total_byte=0;
  u_int32_t sending_size=shem_size;
  long long resid = total_byte0; // bytes
  fprintf(stderr,"Total Byte=%Ld \n", total_byte0);
  while(resid >0){
    if(mode !=TALKER){
      ret = _out_sock.select(Socket::SEL_READ | Socket::SEL_WRITE,0);
      if(ret & 0x01){// ready for read
	status = _out_sock.recv((u_int8_t*)pld, sizeof(Payload)*2);
	fprintf(stderr, " %d Byte received\n", status);
	if( status <=0){
	  perror("Payload Rev Error,");
	}else{
	  fprintf(stderr,"Payload Contents-------------\n");
	  pld->Print();
	  fprintf(stderr,"-----------------------------\n");
	}
      }
      if(!(ret & 0x02)) continue;
    }
/*       long remain=Min((long long)sizeof(u_int32_t)*4,resid); */
/*     u_int8_t * rdadr = dat_adr; */
/*     long sent=0; */
/*     status=0; */
/*     //    while(remain >0){ */
/*       sent = _out_sock.send(rdadr, remain); */
/*       if(sent < 0) break; */
/*       remain -= sent; */
/*       rdadr += sent; */
/*       status += sent; */
/*     } */
    sending_size = Min((long long)shem_size,resid);
    status = _out_sock.send(dat_adr, sending_size); 
    //    fprintf(stderr, " %d Byte sent\n", status);
    if(status ==0){
      fprintf(stderr,"Connection(%d) is already closed\n", LocalClientID);
      break;
    }
    if(status == -1){
      fprintf(stderr,"Error in send() (errno=%d):%s \n", 
	      errno, strerror(errno));
      break;
    }
    //     fputc('.',stderr);
    if( status != sending_size){
      fprintf(stderr,"Error sending size=%ld but actually %d\n", 
	      sending_size, status);
      exit(1);
    }
    resid -= status;
    total_byte += status;
  }// while loop;

  fprintf(stderr," %LD bytes sent\n", total_byte);
  if(total_byte >= total_byte0)
    fprintf(stderr,"Data sent(%.3f MB) Finished\n", 
	    (float)total_byte*1.e-6);
  fprintf(stderr,"Thread(ID=%d) Closed\n", LocalClientID);
  _out_sock.close();
  if(shmdt(dat_adr) ==-1){ perror("shmdt");  }  
}

// Communications with Client sending file  
inline void  ThreadDMY::SendingFileToClient(){
  
  int mtu2 = _out_sock.get_mtu();
  //  u_int8_t sRecvBuf[mtu1];  // Хåե
  u_int8_t sSendBuf[mtu2];  // Хåե
  //  u_int8_t sSendBuf[256];  // Хåե
  
  u_int8_t* dat_adr;

  fprintf(stderr,"%s DEBUG: SendingFileToClient(%d) Started\n", 
	  me,  LocalClientID);
  Socket* fsock = new FileSocket (mtu2);
  fsock->bind(fname,0);
  int zero_cnt=0;
  int status_in, status_out;
  long long total_byte=0;
  int sent=0;
  Payload* pld = new Payload;
  int ok_flag=1;
  
  while((status_in=fsock->recv(sSendBuf,sizeof(sSendBuf)))>=0 && ok_flag){
    if(status_in ==0){
      zero_cnt++;
      if(zero_cnt <10) continue;
      fprintf(stderr,"Fsock read zero 10 times\n");
      break;
    }
    if(status_in <0){
      fprintf(stderr,"SendingFileToClient: fsock->recv Error\n");
      perror("fsock->recv");
      break;
    }

/*     int ret = _out_sock.select(Socket::SEL_READ | Socket::SEL_WRITE,0); */
/*     if(ret & 0x01){// ready for read */
/*       int status = _out_sock.recv((u_int8_t*)pld, sizeof(Payload)); */
/*       fprintf(stderr, " %d Byte received\n", status); */
/*       if( status <=0){ */
/* 	perror("Payload Rev Error,"); */
/*       }else{ */
/* 	fprintf(stderr,"Payload Contents-------------\n"); */
/* 	pld->Print(); */
/* 	fprintf(stderr,"-----------------------------\n"); */
/*       } */
/*     } */
    sent = 0;
    //    if(!(ret & 0x02))
    while(sent < status_in){
      sent = _out_sock.send(sSendBuf+sent, status_in-sent);
      if(sent < 0){
	fprintf(stderr,"SendingFiletoClient Error:\n");
	perror("out_sock.send()");
	ok_flag=0;
	break;
      }
    } // write  
    total_byte += sent;
    fprintf(stderr, " %d Byte sent\r", total_byte);
  } // while file data is remain
   
  if(status_in <0){
    fprintf(stderr,"Exit SendingFileToClient() due to error of fsock->recv()\n");
    //     return ;
  }
   
  if(status_out <0){
    fprintf(stderr,"Error in send() (errno=%d):%s \n", 
	    errno, strerror(errno));
    // return ;
  }
   
  fprintf(stderr," %LD bytes sent\n", total_byte);

  fprintf(stderr,"Thread(ID=%d) Closed\n", LocalClientID);
  fsock->close();
  delete fsock;
  _out_sock.close();
}

inline 
void* ThreadDMY::thread_func(void){
  
  int ThreadSock;    // Thread's Socket
  int mtu2 = _out_sock.get_mtu(); 
  // Cleating New thread for each connection request
  fprintf(stderr,"%s DEBUF:ServerThread (%d):\n", me, LocalClientID);
  //  fprintf(stderr,"Socket is: ");
  //  _out_sock.Print();

  while(1){
    fprintf(stderr,"Waiting connection from client...");
    if( (ThreadSock = _out_sock.accept()) == -1){
      fprintf(stderr,"\n Srv(%d) Accept Error (errno=%d) \n", 
	      LocalClientID, errno);
      perror("Accept Error");
      _out_sock.Error();
      //    Error_accept();
      return 0;
    }
    if(nClientID >4){
      fprintf(stderr,"Number of client (%d) is more than limit 4\n",
	      nClientID);
      // close(ThreadSock);
      shutdown(ThreadSock,SHUT_RDWR);
    }else{
      fprintf(stderr,"Accepted\n");
      break;
    }
  }

  //  Socket*  f_sock = new FileSocket(mtu1);
  Socket*  tcp_sock = new TCPSocket(ThreadSock,mtu2);
  //  f_sock->bind(fname,0);
  tcp_sock->Print();

  //  ThreadDMY thread_obj(*f_sock,*tcp_sock); 
  ThreadDMY thread_obj(*tcp_sock); 
  thread_obj.Set_mode(mode);
  thread_obj.CpyShem(*this);
  fprintf(stderr,"%s DEBUG: Thread generating from ServerThread\n",me);
  proc(); 
  if(fname.length() >0)
    thread_obj.SendingFileToClient();
  else
    thread_obj.CommunicateWithClient();
  //  delete f_sock;
  tcp_sock->shutdown(SHUT_RDWR);
  delete tcp_sock;
}

inline
void StrUpper(char *str, int n){
  int i;
  for(i=0; i<n; i++) str[i] = toupper((int)str[i]);
}

inline
void Init_data(void* data, size_t size, const int ich){
  u_int32_t wc;
  u_int32_t ptn[4] ;
  memset(ptn,0,sizeof(u_int32_t)*4);
  if(ich < 0){
    memset(&wc,0xe4,sizeof(wc));
    wmemset((wchar_t*)data,wc,size/sizeof(wc));
  }else{
    if( ich >15){
      fprintf(stderr,"Error ich must be 0-15, but ich=%d\n", ich);
    }
/*     ptn[1] = 0x01 << ich *2; */
/*     ptn[2] = 0x02 << ich *2; */
/*     ptn[3] = 0x03 << ich *2; */
/*     u_int32_t* pb = (u_int32_t*)data; */
/*     for(int i=0; i<size/16; i++, pb+=4) */
/*       memcpy(pb,ptn,sizeof(u_int32_t)*4); */
    
    wc=1 << ich*2;
    u_int32_t* pb = (u_int32_t*)data; 
    //    wmemset((wchar_t*)data,wc,size/sizeof(wc));
      for(int i=0; i<size/sizeof(wc); i++){
      *pb = wc; pb++;}
  }
}

 // Shard Memory  Initialize
inline
int ThreadDMY::shem_init(unsigned long size){

  shem_size =size;
  if((shem_id=shmget(IPC_PRIVATE,size,IPC_CREAT|0666))==-1){
    perror("shmget");
    return(-1);
  }
  char* adr;
  if((adr = (char*)shmat(shem_id,0,0)) == (char*)-1){
    perror("shmget");
    return(-1);
  }
  Init_data(adr, size, ch_id);
  return(shem_id);
}

#endif
